#!usr/bin/python
# 7/20/2015: this is an old, horrible piece of legacy code that does some convenient things in a very convoluted way.  it calculates enrichment scores and hypergeometric tests for a set of annotations and list of KEGG kos (or whatever maps) are fed into it.

# it is very slow.  just today i deleted some commented code which has not been relevant for years.  note that i am doing an FDR correction based on ALL annotations in the background set- because i am doing a 2-tailed test- which is more conservative (which seems okay to me).

#pieces of this are a little sloppy (though they perform okay- just slow and duplicative),
#could be gainfully made into functions, or removed with an eye to neatness.

#THIS SCRIPT USES A PARTICULAR FORMAT FROM ELHANAN'S PARSED KEGG FILES (which i have
#largely copied in my own updated versions of these files)

# input is two files- one a list of annotations (from clustering or other analysis)
# and one a reference index list with some assignment for each index
# (in my case, a kegg pathway identifier).

# the point of the script is to determine whether these annotations are overrepresented
# in the test list relative to the background list.
import sys
import re
import os

annotation_file = sys.argv[3]

###REQUIRES RPY2 for doing FDR.###
from rpy2.robjects import r

# use linux commands to assemble the lists of annotations in the background and the test set into tmp files.
# sloppy and a little slow, but economical to code. to run on windows etc will have to recode.

os.system('rm test_tmp')
os.system('rm bkgrd_tmp')

os.system('test=`cat '+sys.argv[1]+'`;for ko in $test;do grep $ko '+annotation_file+' >> test_tmp;done')
os.system('bkgrd=`cat '+sys.argv[2]+'`;for ko in $bkgrd;do grep $ko '+annotation_file+' >> bkgrd_tmp;done')

sample = open('test_tmp')	#file for cluster or otherwise IDed list of interest
bkgrd = open('bkgrd_tmp')	#background file

#collapse observations into a dictionary, as a method for counting instances of
#a particular set- work with CLASS annotations for now
sample_dict = {}
sample_dict['Unclassified'] = 0

sampled = 0
for line in sample:
	fields = line.split('\t')
#	annots = ' '.join(fields[1:]).split(';')
	annot = fields[1].strip()
	#sampled += 1
	#if annots[0] == 'Unclassified':
	#	sample_dict['Unclassified'] += 1
	#	continue
	#else:
	sampled += 1
	#for annot in annots:
	if annot.strip() in sample_dict.keys():
		sample_dict[annot.strip()] += 1
	else:
		sample_dict[annot.strip()] = 1

bkgrd_dict = {}
bkgrded = 0
bkgrd_dict['Unclassified'] = 0
for line in bkgrd:
        fields = line.split('\t')
      #  annots = ' '.join(fields[1:]).split(';')
	annot = fields[1].strip()
	bkgrded += 1
        #if annots[0] == 'Unclassified':
        #       bkgrd_dict['Unclassified'] += 1
	#	continue
        #else:
        #        bkgrded += 1
        #for annot in annots:
        if annot.strip() in bkgrd_dict.keys():
		bkgrd_dict[annot.strip()] += 1
        else:
		bkgrd_dict[annot.strip()] = 1


#NOW USING RPY- for each pathway level, calculate p-values etc
p_dict = {}
p_lower = {}
n=bkgrded
k=sampled
#ps_alone = open('raw_pvals.txt','w')
#print bkgrd_dict.keys()

or_dict = {}
omit = 0
#print sample_dict
#print bkgrd_dict
for path in bkgrd_dict.keys():
	if path not in sample_dict.keys():
		continue
#	print path
	if bkgrd_dict[path] < 4 or sample_dict.setdefault(path,0) <4:
#		omit+=1
		continue
	x = sample_dict.setdefault(path,0)
	m = bkgrd_dict[path]
	N = n - m
#	print path, x, m, n, k
	r.assign('x',x)
	r.assign('m',m)
	r.assign('N',N)
	r.assign('k',k)
	or_dict[path] = (float(x)/k) / (float(m)/n)
	p_dict[path] =list(r('dhyper(x,m,N,k)'))[0]
#	print p_dict[path]
#print p_dict.keys()

p_list = []
p_paths = []
#ps_alone.close()
for path in p_dict.keys():
	p_paths.append(path)
	p_list.append(p_dict[path])

# now port things back into R to do corrections
r.assign('plist',p_list)
r.assign('ppaths',p_paths)
r.assign('k',k)
# fdr function 'fdrtool' acts really weird, switch to R builtin 'p.adjust'. can also get bonferroni easily.
# currently correcting by length of BACKGROUND list, to correct by TEST list just remove the 'n=N' parameter.

r('qs <- p.adjust(as.numeric(plist),method="fdr")')
#r('print(summary(qs))')
# uncomment below to get bonferroni correction on p-vals.
#r('ps<-as.numeric(plist)*k')
#r('sigs = which(ps<.05)')
#print 'threshold is p <',.05/k
r('sigs = which(qs < .01)')
#r('sigs = which(qs < .05)')
enriched = list(r('ppaths[sigs]'))

#r('write.table(cbind(plist,qs),"outqs",quote=F)')
#r('print(sigs)')
#print enriched
#print len(enriched)
out = 'Enriched pathways\tp-values\tin test set\tin background set\tEnrichment ratio\n'

sub_pat = re.compile(r'[\"\n]|\[[0-9]+\] ')
for path in enriched:
	#print path
	path=str(path).strip()
	path=re.sub(r'[\"]|\[[0-9]+\] ','',path)
	out = out+ path+'\t'+str(p_dict[path])+'\t'+str(sample_dict[path])+'\t'+str(bkgrd_dict[path])+'\t'+str(or_dict[path])+'\n'

#print out

outfile = open(sys.argv[4],'w')
outfile.write(out)
outfile.close()
sample.close()
bkgrd.close()
